theory VSPLTermEx
imports VSPLSimpleEx
begin

text{*
 Hier deklarieren wir ein Atom @{term P}.
 *}

consts
  P :: "o"
  Q :: "o"

text{* Damit läßt sich @{thm conj_comm} wie vorher beweisen. *}
lemma conj_comm_PQ: "P \<and> Q \<longrightarrow> Q \<and> P"
  apply (rule impI, rule conjI)
  apply (erule conjE2, erule conjE1)
  done

text{* 
  Wir können das schon bewiesene Theorem benutzen.  
  Isabelle instantiiert bei der Anwendung die Variablen X und Y mit  
  dem Term P und Q. 
  *}
lemma "P \<and> Q \<longrightarrow> Q \<and> P"
 apply (rule conj_comm)
 done

lemmas cc_alt = conj_comm [where X= "P" and Y= "Q"]

text{* 
  Auf der anderen Seite kann ich conj_comm_PQ nicht benutzen, um das
  Originaltheorem zu zeigen: 
  *}
  
lemma "X \<and> Y \<longrightarrow> Y \<and> X"
  apply (rule conj_comm_PQ)
  oops --{* Damit brechen wir erfolglose Beweise ab. *}

end
